<?php
#####################################################################################################
#
#					Module pour la plateforme de paiement PayZen
#						Version : 2.7 (rvision 50032)
#									########################
#					Dvelopp pour VirtueMart
#						Version : 1.1.4
#						Compatibilit plateforme : V2
#									########################
#					Dvelopp par Lyra Network
#						http://www.lyra-network.com/
#						05/08/2013
#						Contact : support@payzen.eu
#
#####################################################################################################

/**
 * Processing server to server payment confirmation.
 */

if(!defined('_VALID_MOS') && !defined('_JEXEC')) die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

// loading appropriate module
if((key_exists('vads_payment_config', $_POST) && stripos($_POST['vads_payment_config'], 'MULTI') !== false)
		|| (key_exists('vads_contrib', $_POST) && stripos($_POST['vads_contrib'], 'multi') !== false)) {

	require_once(PAGEPATH . 'checkout.payzen_multi_rsts.php');

	die();
}

require_once(CLASSPATH . 'payment/ps_payzen.cfg.php');
require_once(CLASSPATH . 'payment/ps_payzen.php');
require_once(CLASSPATH . 'ps_order.php');

$ps_payzen = new ps_payzen();

$response = new PayzenResponse($_POST, PAYZEN_CTX_MODE, PAYZEN_KEY_TEST, PAYZEN_KEY_PROD);

// check request authenticity
if(! $response->isAuthentified()) {
	die($response->getOutputForGateway('auth_fail'));
}

// retrieve order from db
$db = new ps_DB();
$orderId = $db->getEscaped($response->get('order_id'));
$db->query('SELECT order_status_code FROM #__{vm}_order_history WHERE order_id='.$orderId.' ORDER BY date_added DESC');

if($db->num_rows() <= 0) {
	// order not found
	die($response->getOutputForGateway('order_not_found'));
} else {
	$db->next_record();

	if($db->f('order_status_code') == 'P') {
		// order not confirmed yet

		// notify customer ?
		$notify = (PAYZEN_NOTIFY_CUSTOMER_ENABLED == '1');

		if($response->isAcceptedPayment()) {
			// save order with verified status ...
			$ps_payzen->update_order($response, PAYZEN_VERIFIED_STATUS, $notify);

			// ... and show success server response
			die($response->getOutputForGateway('payment_ok'));
				
		} else {
			// payment failed, save order with invalid status ...
			$ps_payzen->update_order($response, PAYZEN_INVALID_STATUS);

			// ... and show failure server response
			die($response->getOutputForGateway('payment_ko'));
		}
	}

	else {
		// order already saved

		if($db->f('order_status_code') == PAYZEN_VERIFIED_STATUS && $response->isAcceptedPayment()) {
			// payment success reconfirmed, just show success server response
			die($response->getOutputForGateway('payment_ok_already_done'));

		} elseif($db->f('order_status_code') == PAYZEN_INVALID_STATUS && !$response->isAcceptedPayment()) {
			// payment failure reconfirmed, just show failure server response
			die($response->getOutputForGateway('payment_ko_already_done'));
				
		} else {
			// error ! order status not correspending to payment result
			die($response->getOutputForGateway('payment_ko_on_order_ok'));
		}
	}
}
?>